/* ######################################################################### */
/* #                                                                       # */
/* #                                                                       # */
/* #                Copyright (c) 2012 Sintesio Org.                       # */
/* #                                                                       # */
/* #                                                                       # */
/* # File Name    : DiameterMessageDecodeException.java                    # */
/* #                                                                       # */
/* # File Code    :                                                        # */
/* #                                                                       # */
/* # Description  : Implementation of DIAMETER parser class.               # */
/* #                                                                       # */
/* # Revision     : 1.0                                                    # */
/* #                                                                       # */
/* # Project Name :                                                        # */
/* #                                                                       # */
/* # Date         : Apr 2012                                               # */
/* #                                                                       # */
/* # Author       : Sintesio                                               # */
/* #                                                                       # */
/* # Translation  : javac                                                  # */
/* #                                                                       # */
/* #                                                                       # */
/* ######################################################################### */

package com.iskratel.protocol.diameter.parser;

/**
 * Exception thrown by methods that decode a DiameterMessage.
 * 
 * @author Dragos Vingarzan vingarzan -at- fokus dot fraunhofer dot de
 */
public class DiameterMessageDecodeException extends Exception {

	private static final long serialVersionUID = 7857109165468319995L;

	/**
	 * Constructs a DiameterMessageDecodeException with the specified detail 
	 * message.
	 * 
	 * @param message	The detail message pertaining to this exception.
	 */
	public DiameterMessageDecodeException(String message)
	{
		super(message);
	}
}
