/**
 *  @author     TTF006
 *  @version    $Id: $
 *  @desc       This module provides offline capturing test adapter for VxLTE.
 *  @see        
 */
package com.iskratel.ttcn.tri;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
//import java.util.Arrays.*;
import org.apache.log4j.Logger;
import org.etsi.ttcn.tri.TriAddress;
import org.etsi.ttcn.tri.TriMessage;

import com.iskratel.ttcn.tri.IotConnectionOffline.FilterPackets;
import com.testingtech.ttcn.tri.TriAddressImpl;
import com.testingtech.ttcn.tri.TriMessageImpl;

import jpcap.JpcapCaptor;
import jpcap.PacketReceiver;
import jpcap.packet.Packet;
//import jpcap.packet.RawIpPacket;
import jpcap.packet.IPPacket;
import jpcap.packet.TCPPacket;
import jpcap.packet.UDPPacket;
import jpcap.packet.SCTPPacket;

public class ReadCaptureThread extends Thread implements Runnable{
	
	String name;
	Thread t;
	JpcapCaptor pcap = null;
	String tf;//tracefilename
	FilterPackets fp; //filterpackets structure with component and ports
	Logger log = null;
	
	ReadCaptureThread (String threadname){
		name = threadname;
		t=new Thread(this,name);
		t.start();
	}
	
	ReadCaptureThread (String threadname,Logger loger, String tracefile,FilterPackets filterpackets){
		log = loger;
		name = threadname;
		tf = tracefile;
		fp = filterpackets;
		if (fp != null) {
			//log.info("ReadCaptureThread: " + threadname + ": fp=" + filterpackets);
		}
		t=new Thread(this,name);
		t.start();
	}

	public String tracefile="";
	PacketHandler ph;
	//RawPacketHandler rph;
	
	
	public void run(){
		
		//try{
    	    // open devices for capturing (requires root)
    	    try {
    	    	pcap = JpcapCaptor.openFile(this.tf);
    		} catch (IOException e) {
    			log.debug(e.getMessage());
    		}
    	       
    	    try{
	     	    // add a BPF filter (see tcpdump documentation)
    	    	log.debug("ReadCaptureThread: fp.filter=" + ((fp != null) ? fp.filter : "null"));
    	    	//if (fp.filter.startsWith("udp")){
    	    		//log.info(">>> filter=" + "(vlan and " + fp.filter+") or ("+fp.filter+")");
    	    		//pcap.setFilter("(vlan and " + fp.filter+") or ("+fp.filter+")", true);		
    	    	//	pcap.setFilter(/*"ip"*/fp.filter, true);
    	    	//}else{
    	    		pcap.setFilter(fp.filter, true);
    	    	//}
    	    } catch (IOException e) {
    				
    			log.debug(this.name+" "+e.getMessage() + "\n");// +e.getStackTrace().toString());
    		}

	     	    // create a handler
	     	    // packet
//	     	    ph = new PacketHandler(fp);
//	     	    pcap.addPacketListener(ph);
	
	     	    // raw
	     	    //rph = new RawPacketHandler("offline");
	     	    //JpcapCaptor.addRawPacketListener(rph);
	
	     	    // capture packets-INFINITE=-1 //***** copied to start capture command
//	            pcap.capture(200);
    	    	
    	    	try {
    	    		pcap.loopPacket(-1, new PacketHandler(fp));
    	    	}
    	    	finally {
    	    		
    	    	}
    	    	
	     	    
			
		//}catch(/*Interrupted*/Exception e){log.debug(this.name+" "+e.getMessage()+ "\n");}
		
		log.debug("Thread ended! "+name);//+" packets " +fp.packets.size());
	}
	
	class PacketHandler implements PacketReceiver 
	{ 
	  String name;
	  private int counter = 0;
	  //private List<Packet> packets;
	  private FilterPackets filterpackets;
	  private Map<Long, _fragmented_packet> _fragments = null;
	  
	  
	  private class _fragmented_packet {
		Packet _packet;

		public _fragmented_packet(Packet p_packet) {
			_packet = p_packet;
		}

		public void appendData(final byte[] p_data) {
			_packet.data = concat(_packet.data, p_data);
			_packet.len = _packet.data.length;
			_packet.caplen = _packet.data.length;
		}

		public Packet getPacket() {
			return _packet;
		}

		private byte[] concat(byte[]... arrays) {
			// Determine the length of the result array
			int totalLength = 0;
			for (int i = 0; i < arrays.length; i++) {
				totalLength += arrays[i].length;
			}

			// create the result array
			byte[] result = new byte[totalLength];

			// copy the source arrays into the result array
			int currentIndex = 0;
			for (int i = 0; i < arrays.length; i++) {
				System.arraycopy(arrays[i], 0, result, currentIndex, arrays[i].length);
				currentIndex += arrays[i].length;
			}

			return result;
		}
	  } // End of class _fragmented_packet
	 	  
	  public PacketHandler(String name) {
	    this.name = name;
	    _fragments = new HashMap<Long, _fragmented_packet>();
	  }
	  
	  public PacketHandler(FilterPackets filterpackets) {
	    this.name = filterpackets.componentId.getComponentName();
	    this.filterpackets = filterpackets;
	    _fragments = new HashMap<Long, _fragmented_packet>();
	  }
	  
	  public void receivePacket(Packet packet) {
	    this.counter++;
	    //String type = packet.getClass().getName();
	    //log.debug(name + ": Packet(" + counter + ") is of type " + type +".");
	    
//	    if (packet instanceof EthernetPacket){
//	    	final byte[] data = ((EthernetPacket)(packet)).getData();
//	    	//System.err.println(new String( data,0,data.length));
//	    	//System.err.println(((EthernetPacket)(packet)).getProtocol());
//	    }
	    
	    Packet new_packet = null;
		if (packet instanceof IPPacket) {
			IPPacket ipPacket = (IPPacket) packet;
			// Check fragmentation
			if (ipPacket.more_frag == true) { // First or next fragment
				if (!_fragments.containsKey((long) ipPacket.ident)) {
					// Create new entry with the first fragment
					_fragments.put((long) ipPacket.ident, new _fragmented_packet(packet));
				} else {
					// Append the next fragment...
					_fragments.get((long) ipPacket.ident).appendData(ipPacket.data);
				}
				// ...And process next packet
				return;
			} else if (ipPacket.dont_frag == false) { // Last segment
				if (_fragments.containsKey((long) ipPacket.ident)) {
					// Add last fragment
					_fragments.get((long) ipPacket.ident).appendData(ipPacket.data);
					new_packet = _fragments.get((long) ipPacket.ident).getPacket();
					//System.out.println("Final packet: " + new_packet.getClass().getName());
					// Remove entry
					_fragments.remove((long) ipPacket.ident);
				}
			} else {
				new_packet = packet;
			}
		}
	    
    	if(new_packet instanceof TCPPacket) {
 	    	TCPPacket tcpPacket = (TCPPacket)new_packet;
 	    	byte[] message= tcpPacket.data;//.getTCPData();//TODO: assume data is in one packet
 	    	 	    	
 	    	//String srcHost = tcpPacket.src_ip.toString();
 	    	//String dstHost = tcpPacket.dst_ip.toString();
 	    	//String isoData = new String(data);//, "ISO-8859-1");
 	    	//log.debug(srcHost+" -> " + dstHost );//+ ": " + isoData);
			    
 		    TriMessage triMessage =TriMessageImpl.valueOf(message);
 			TriAddress triAddress = new TriAddressImpl(new byte[] {});
 			
 			synchronized(this.filterpackets.cte) { 
				log.debug("ENQUE"+this.filterpackets.tsiPortId.toString()+" "+ this.filterpackets.componentId.getComponentName().toString());
				this.filterpackets.cte.triEnqueueMsg(this.filterpackets.tsiPortId, triAddress, this.filterpackets.componentId, triMessage);
 			}
 	    }
    	
 	    if (new_packet instanceof UDPPacket){
 	    	UDPPacket udpPacket = (UDPPacket)new_packet;
 	    	byte[] message = udpPacket.data;//.getUDPData();//TODO: assume data is in one packet
 	   	   
 	   	    //String srcHost = udpPacket.src_ip.toString();
 	    	//String dstHost = udpPacket.dst_ip.toString();
 	    	//String isoData = new String(data);//, "ISO-8859-1");
 	    	//log.debug(srcHost+" -> " + dstHost );//+ ": " + isoData);
    
 		    TriMessage triMessage =TriMessageImpl.valueOf(message);
 			TriAddress triAddress = new TriAddressImpl(new byte[] {});
            
 			synchronized(this.filterpackets.cte) { 
				log.debug("ENQUE"+this.filterpackets.tsiPortId.toString()+" "+ this.filterpackets.componentId.getComponentName().toString());
				this.filterpackets.cte.triEnqueueMsg(this.filterpackets.tsiPortId, triAddress, this.filterpackets.componentId, triMessage);
 			} 
 	    }
 	    
 	   if (new_packet instanceof SCTPPacket){
	    	SCTPPacket sctpPacket = (SCTPPacket)new_packet;
	    	byte[] message = sctpPacket.data;//getData();//.getUDPData();//TODO: assume data is in one packet
	    		    	
	    	//String srcHost = sctpPacket.src_ip.toString();//getSourceAddress();
	    	//String dstHost = sctpPacket.dst_ip.toString();//getDestinationAddress();
	    	//String isoData = new String(data);//, "ISO-8859-1");
	    	//log.debug(srcHost+" -> " + dstHost );//+ ": " + isoData);
	    	//log.debug(sctpPacket.toColoredString(false));
	    	
	    	int i=0;
	        while(i < sctpPacket.chunks.length) {
	        	if (sctpPacket.chunks[i].type == 0 ) //DATA_CHUNKTYPE
	        	{	
	        	    message = java.util.Arrays.copyOfRange(sctpPacket.chunks[i].data, 0+12, sctpPacket.chunks[i].data.length);//12 - length of DATAchunks parameters
  
    			    TriMessage triMessage =TriMessageImpl.valueOf(message);
	    			TriAddress triAddress = new TriAddressImpl(new byte[] {});
	               
			    	synchronized(this.filterpackets.cte) { 
				    	log.debug("ENQUE"+this.filterpackets.tsiPortId.toString()+" "+ this.filterpackets.componentId.getComponentName().toString());
					    this.filterpackets.cte.triEnqueueMsg(this.filterpackets.tsiPortId, triAddress, this.filterpackets.componentId, triMessage);
				    }
	        	}
	            i++;
	        }
 	   }
 	    
	  }
	   
//	   public List<Packet> getPackets(){
//		  return this.packets;
//	   }
	}

	class RawPacketHandler implements PacketReceiver 
	{ 
	  String name;
	  private int counter = 0;
	  //private List<RawPacket> rawpackets;

	  public RawPacketHandler(String name) {
	    this.name = name;
	  }

	  public void receivePacket(Packet packet) {
	    this.counter++;
	    //rawpackets.add(rawPacket);
	    //System.err.println(rawPacket.getClass().toString()/*rawPacket*/);	   
	  }
	  
//	  public List<RawPacket> getPackets(){
//		  return this.rawpackets;
//	   }	  
	}

}
