package jpcap.packet;

public class TTYPacket extends CustomDatalinkPacket {		
	private static final long serialVersionUID = -3937142561689924849L;
	
	public static final byte TERMINAL_TO_SERVER = 1;
	public static final byte SERVER_TO_TERMINAL = 0;
	
	public static final byte SSH_CONNECTION = 101;
	public static final byte LOCAL_CONNECTION = 102;
	public static final byte TELNET_CONNECTION = 103;

	public static final byte VERSION = 1;
	public static final byte PACKET_CONT_VERSION = 127;
	
	public byte version;
	public byte connectionType;
	public byte direction;
	public int terminalWidth;
  public int terminalHeight;	
	public String encoding;
	public String sessionId;
	public String connectionParameters;
	
	public TTYPacket() {	  
	}
	
  public TTYPacket(byte connectionType, byte direction, 
    int terminalWidth, int terminalHeight, String encoding, 
    String sessionId, String connectionParameters) 
  {
    // this is the constructor for v1
    setValue((byte)1, connectionType, direction, 
        terminalWidth, terminalHeight, encoding, 
        sessionId, connectionParameters);
  }
	
	public void setValue(byte version, byte connectionType, byte direction, 
	    int terminalWidth, int terminalHeight, String encoding, 
	    String sessionId, String connectionParameters) 
	{
	  this.version = version;
	  this.connectionType = connectionType;
		this.direction = direction;
		this.terminalHeight = terminalHeight;
    this.terminalWidth = terminalWidth;
		this.encoding = encoding;
		this.sessionId = sessionId;
		this.connectionParameters = connectionParameters;
	}
}
